Program Interpol;

Const N=10;

Type Funkcija=Function (X: real): real;

Var x,y: array[0..N] of real;
      Pts,h: real;

{---------------------------------------------------------------------------}
Function Pakape(x_,w: real): real;
Begin
    Pakape:=Exp(w*ln(x_))
End;

{$F+}
{---------------------------------------------------------------------------}
Function F1(x: real): real;
Begin
     F1:=(sqrt(x*x*x*x*x*x*x)-sqrt(x*x*x*x*x))/(1-x)
End;

{---------------------------------------------------------------------------}
Function F2(x: real): real;
Begin
     F2:=(x*x*x*x*arctan(x))/(1+x*x)
End;

{---------------------------------------------------------------------------}
Function F1_otrais_atv(x_: real): real;
Begin
     F1_otrais_atv:=(Sqrt(x_)*(-15-15*x_-33*x_*x_+3*x_*x_*x_+sqrt(35*x_*x_*x_*x_*x_*x_*x_)
     +4*x_*x_*x_*x_+35*sqrt(x_*x_*x_*x_*x_*x_*x_*x_*x_)-21*sqrt(x_*x_*x_*x_*x_*x_*x_*x_*x_*x_*x_)-
     21*sqrt(x_*x_*x_*x_*x_*x_*x_*x_*x_*x_*x_*x_*x_)))/(4*(x_-1)*(x_-1)*(x_+1)*(x_+1)*(x_+1))
End;

{---------------------------------------------------------------------------}
Function F2_otrais_atv(x_: real): real;
Begin
     F2_otrais_atv:=(2*x_*x_*(4*x_+x_*x_*x_-2*x_*x_*x_*x_*x_+6*Arctan(x_)+3*x_*x_
     *Arctan(x_)-7*x_*x_*x_*x_*Arctan(x_)-4*x_*x_*x_*x_*x_*x_*Arctan(x_)))/((1+x_*x_)*(1+x_*x_)*(1+x_*x_))
End;
{$F-}

{--------------------------------------------------------------------------}
Procedure Tabula(F: Funkcija; a,b: real);
Var x_: real;
    i: byte;
Begin
     h:=(b-a)/N;
     Pts:=a+h/2;

     x_:=a;
     For i:=0 to N do begin
                      x[i]:=x_;
                      y[i]:=F(x_);
                      x_:=x_+h
                      end;
End;

{---------------------------------------------------------------------------}
Function Lagranz: real;

         {-------}
         Function L(j: byte; x_: real): real;
         Var r: real;
             k: byte;
         Begin
              r:=1;
              For k:=0 to N do
                  if k<>j then r:=r*(x_-x[k])/(x[j]-x[k]);
              L:=r
         End;

Var s: real;
    m: byte;
Begin
     s:=0;
     For m:=0 to N do
         s:=s+L(m, Pts)*y[m];
     Lagranz:=s
End;

{--------------------------------------------------------------------------}
Function Newton: real;
Var P,t: real;
    m,l: byte;

         {-----}
         Function Delta(k: byte): real;
         Var r,d: real;
             j,i: byte;
         Begin
              d:=0;
              for i:=0 to k do begin
                          r:=1;
                          for j:=0 to k do
                              if j<>i then r:=r*(x[i]-x[j]);
                          d:=d+y[i]/r
                                end;
              Delta:=d
         End;

Begin
     P:=y[0];
     for m:=1 to N do begin
              t:=Delta(m);
              for l:=0 to m-1 do t:=t*(Pts-x[l]);
              P:=P+t
                         end;
     Newton:=P
End;

{--------------------------------------------------------------------------}
Function Splaini(F_otrais_atv: Funkcija; i: byte; x_:real): real;
Var M,C,D: array[0..N] of real;

         {-----}
         Procedure Izrek_M_C_D(F_oa: Funkcija);
         Var A,B: array[1..(N-1)] of real;
             i_: byte;
         Begin
              M[0]:=F_oa(x[0]);
              M[N]:=F_oa(x[N]);

              A[1]:=(-h/6)/(2*h/3);
              B[1]:=((y[2]-2*y[1]+y[0])/h-h*M[0]/6)/(2*h/3);

              for i_:=2 to N-1 do begin
             B[i_]:=((y[2]-2*y[1]+y[0])/h-h*B[i_-1]/6)/(2*h/3+h*A[i_-1]/6);
             A[i_]:=(-h/6)/(2*h/3+h*A[i_-1]/6)
                                 end;

              for i_:=N-1 downto 2 do
                  M[i_]:=A[i_]*M[i_+1]+B[i_];

              {-----}
              for i_:=1 to N do begin
           C[i_]:=(y[i_]-y[i_-1]-sqr(h)*(M[i_]-M[i_-1])/6)/(x[i_]-x[i_-1]);
           D[i_]:=y[i_]-sqr(h)*M[i_]/6-C[i_]*x[i_]
                               end
              End;
Begin
     Izrek_M_C_D(F_otrais_atv);
     Splaini:=Pakape(x_-x[i-1],3)*M[i]/(6*h)+
              Pakape(x[i]-x_,3)*M[i-1]/(6*h)+
              C[i]*x[i]+D[i]
End;

{--------------------------------------------------------------------------}
Procedure Rezultati(F,F_otr_atv: Funkcija; a,b: real);
Var Tuv, Prec, Kl: real;
Begin
     Tabula(F,a,b);

     Prec:=F(Pts);
     Writeln('F(',Pts:5:5,')=',Prec:5:5,' - precizi');
     Writeln('--------------------------------------------------');

     Tuv:=Lagranz;
     Kl:=100*abs(Tuv-Prec)/Prec;
     Writeln('F(',Pts:5:5,')=',Tuv:5:5,' - ar Lagranza metodi');
     Writeln('Kluda: ', Kl:5:5 ,'%');
     Writeln;

     Tuv:=Newton;
     Kl:=100*abs(Tuv-Prec)/Prec;
     Writeln('F(',Pts:5:5,')=',Tuv:5:5,' - ar Nutona metodi');
     Writeln('Kluda: ', Kl:5:5 ,'%');
     Writeln;

     Tuv:=Splaini(F_otr_atv,1,a+h/2);
     Kl:=100*abs(Tuv-Prec)/Prec;
     Writeln('F(',Pts:5:5,')=',Tuv:5:5,' - ar kubiskiem splainiem');
     Writeln('Kluda: ', Kl:5:5 ,'%')
End;


BEGIN
     {Rezultati(F1, F1_otrais_atv,0,1)};
     Rezultati(F2, F2_otrais_atv,0,1)
END.
