Program Interpol;

Const N=10;

Type Funkcija=Function (X: real): real;

Var x,y: array[0..N] of real;
      Pts,h: real;

{$F+}
Function F1(x: real): real;
Begin
     F1:=cos(x)/(sin(x+0.00001)*(1+sin(x+0.00001)));
End;

{---------------------------------------------------------------------------}
Function F2(x: real): real;
Begin
     F2:=Exp(Exp(1.0)*ln(x))
End;
{$F-}

{--------------------------------------------------------------------------}
Procedure Tabula(F: Funkcija; a,b: real);
Var x_: real;
    i: byte;
Begin
     h:=(b-a)/N;
     Pts:=a+h/2;

     x_:=a;
     For i:=0 to N do begin
                      x[i]:=x_;
                      y[i]:=F(x_);
                      x_:=x_+h
                      end;
End;

{---------------------------------------------------------------------------}
Function Lagranz: real;

         {-------}
         Function L(j: byte; x_: real): real;
         Var r: real;
             k: byte;
         Begin
              r:=1;
              For k:=0 to N do
                  if k<>j then r:=r*(x_-x[k])/(x[j]-x[k]);
              L:=r
         End;

Var s: real;
    m: byte;
Begin
     s:=0;
     For m:=0 to N do
         s:=s+L(m, Pts)*y[m];
     Lagranz:=s
End;

{--------------------------------------------------------------------------}
Function Newton: real;
Var P,t: real;
    m,l: byte;

         {-----}
         Function Delta(k: byte): real;
         Var r,d: real;
             j,i: byte;
         Begin
              d:=0;
              for i:=0 to k do begin
                          r:=1;
                          for j:=0 to k do
                              if j<>i then r:=r*(x[i]-x[j]);
                          d:=d+y[i]/r
                                end;
              Delta:=d
         End;

Begin
     P:=y[0];
     for m:=1 to N do begin
              t:=Delta(m);
              for l:=0 to m-1 do t:=t*(Pts-x[l]);
              P:=P+t
                         end;
     Newton:=P
End;

{--------------------------------------------------------------------------}
Procedure Rezultati(F: Funkcija; a,b: real);
Var Tuv, Prec, Kl: real;
Begin
     Tabula(F,a,b);

     Prec:=F(Pts);
     Writeln('F(',Pts:5:5,')=',Prec:5:5,' - precizi');
     Tuv:=Lagranz;
     Kl:=100*abs(Tuv-Prec)/Prec;
     Writeln('F(',Pts:5:5,')=',Tuv:5:5,' - ar Lagranza metodi');
     Writeln('Kluda: ', Kl:5:5 ,'%');
     Writeln;

     Tuv:=Newton;
     Kl:=100*abs(Tuv-Prec)/Prec;
     Writeln('F(',Pts:5:5,')=',Tuv:5:5,' - ar Nutona metodi');
     Writeln('Kluda: ', Kl:5:5 ,'%');
     Writeln;

End;


BEGIN
     writeln('Pirmaa fja');
     Rezultati(F1,0,pi/2);
     writeln;
     writeln('Otraa fja');
     Rezultati(F2,1,2);
     readln
END.
