program Interpolation;

uses
  Crt;

const
  n = 100;
  a = 0;
  b = Pi/2;

var
  K: array[1..n-1,1..4] of real;
  M: array[0..n] of real;
  M0,Mn: real;
  h: real;
  Fraction: real;

function f(x: real): real;
begin
  f:=cos(x)/(2+cos(x))
end;

function S(x,Xi,Mi,Mim1,Ci,Di: real): real;
begin
  S:=Sqr(x-Xi+h)*(x-Xi+h)*Mi/(6*h)+Sqr(Xi-x)*(Xi-x)*Mim1/(6*h)+Ci*x+Di
end;

function Spline(x: real):real;
var
  j: integer;
  Xj,C,D: real;
begin
  j:=Round(Int(x/h));
  Xj:=a+h*j;
  C:=(f(Xj)-f(Xj-h)-Sqr(h)*(M[j]-M[j-1])/6)/h;
  D:=f(Xj)-M[j]*Sqr(h)/6-C*Xj;
  Spline:=S(x,Xj,M[j],M[j-1],C,D)
end;

procedure FillArray;
var
  i: integer;
begin
  M[0]:=M0;
  M[n]:=Mn;

  k[1,1]:=2*h/3;
  k[1,2]:=h/6;
  k[1,3]:=(f(a+h*2)-f(a+h))/h-(f(a+h)-f(a))/h-M0*h/6;
  k[1,4]:=0;
  for i:=2 to n-2 do
    begin
      k[i,1]:=h/6;
      k[i,2]:=2*h/3;
      k[i,3]:=h/6;
      k[i,4]:=(f(a+h*(i+1))-f(a+h*i))/h-(f(a+h*i)-f(a+h*(i-1)))/h;
    end;
  k[n-1,1]:=h/6;
  k[n-1,2]:=2*h/3;
  k[n-1,3]:=(f(b)-f(b-h))/h-f(b-h)-f(b-2*h)/h-Mn*h/6;
  k[n-1,4]:=0;

  for i:=1 to n-3 do
    begin
      Fraction:=k[i+1,1]/k[i,1];
      k[i+1,1]:=k[i+1,2]-k[i,2]*Fraction;
      k[i+1,2]:=k[i+1,3];
      k[i+1,3]:=k[i+1,4]-k[i,3]*Fraction;
      k[i+1,4]:=0;
    end;

  M[n-1]:=(k[n-1,3]*k[n-2,1]-k[n-1,1]*k[n-2,3])/(k[n-2,1]*k[n-1,2]-k[n-1,1]*k[n-2,2]);
  for i:=n-2 downto 1 do
    M[i]:=(k[i,3]-k[i,2]*M[i+1])/k[i,1];
end;

begin
  ClrScr;
  M0:=-0.22222222;
  Mn:=-0.5;
  h:=(b-a)/n;
  FillArray;
  WriteLn(Spline({(b-a)/(2*n)}1):0:7);
end.